﻿# The script of the game goes in this file.

# Declare characters used by this game. The color argument colorizes the
# name of the character.

define w = Character("Wormy", image="wormy", kind=bubble)
define wm = Character("Wormom", image="wormom", kind=bubble)
define b = Character("Boss", image="boss", kind=bubble)
define m = Character("Mimi", image="mimi", kind=bubble)
define c = Character("???", image="creature", kind=bubble)
define k = Character("COMPUTER", image="comp", kind=bubble)
define n = Character("Nighten", image="nighten", kind=bubble)

image CAVEBACKCOLOR = Solid("#74569b")
image MENUCOLOR = Solid("#d8bfd8")


define flash = Fade(0.1, 0.0, 0.5, color="#fff")

# The game starts here.

label start:
    scene MENUCOLOR
    show cover with None
    show screen CAVE() with dissolve
    pause 0.5
    scene CAVEBACKCOLOR
    call screen CAVE()

    return

label boss_introduction:
    scene camp entrance with None
    show boss angry 02 :
        align (0.25, 0.5)
        xoffset 5

    b 01 "Hey you, who are you?"
    b serious "You don't look like one of those looters..."
    b happy 02 "Maybe you are the new recruit for the mine?"
    b 01 "I'm glad you finally arrived!"
    b happy 01  "If you're willing to work honestly, you're welcome"
    b serious "Nowadays it's almost impossible to find good people to work with..."
    b happy 01 "Alright, I will be your {b}boss{/b} from now on"
    b 02 "And your job will be to dig the mine, but not for ores"
    b 01 "But to dig some special relics from the old world!"
    b serious "Enough chit-chat, I want you to get to work now"
    b happy 02 "Go and talk to your colleague, {b}Mimi{/b}"
    b 01 "She right at the entrance"
    hide boss with dissolve
    scene CAVEBACKCOLOR
    call screen CAVE("CAMP ENTRANCE")
    return

label mimi_introduction:
    scene entrance with None
    show mimi happy 02 :
        align (0.8, 0.8)

    m 01 "Oh hi there!"
    m 02  "So you're the new recruit? Welcome to the job!"
    m 01  "My name is {b}Mimi{/b}, nice to meet you"
    m surprised  "You don't look like you came with your equipment"
    $renpy.notify("+ You received a pickaxe!")
    m happy 02 "Here's a pickaxe for you"
    m 01 "Did you worked in a mine before?"
    m 02 "It's alright, it pays the bills"
    m 01 "At least we are away from the sun, and it's not {i}too{/i} dangerous,"
    m 02 "Let's get to work now, don't want the {b}boss{/b} to be upset"

    hide mimi with dissolve

    scene CAVEBACKCOLOR
    call screen CAVE("CAVE ENTRANCE")
    return

label wormy_room_03:
    scene room 03 a with None
    show wormy angry 02 :
        align (0.5,0.85)

    w 01 "Whaaaa"
    w 02  "WHO ARE YOU??"
    w 01  "What are you doing in MY cave???"
    w 02 "You look like a fool, human"
    w 01 "Anyone coming here is a fool!!"
    w 02 "But I'll not punish you right away, I'm too good for that"
    w 01 "I just came to warn you..."
    w 02  "If I see your gut ever again it's gonna end badly!!"
    w 01  "UNDERSTOOD??"
    hide wormy with dissolve

    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 03")
    return

label mimi_room_01:
    scene room 01 with None
    show mimi happy 02 :
        align (0.7, 0.8)
        offset (-5,-7)

    if first_explosion:
        m 01 "Hehe, sorry for the noise"
        m 02 "I didn't need to go that hard, but what's the fun of toning it down?"
        m 01 "Anyway, the path is clear now"
    else:
        m surprised "Oh you already found a chip? That's so cool!"
        m happy 02 "Go bring it to the {b}boss{/b}, he should be in the tent"
        m 01 "I would love to see his reaction"
        m 02 "But I have work to do here..."
        m "{size=-10}hehe{/size}"

    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 01")
    return

label boss_tent:
    scene tent with None
    show boss happy 02 :
        align (0.3, 0.5)
        offset (5, 0)

    if first_explosion == False:
        if first_chip_retrieved:
            if computer_is_accessible == False:
                show tent_computer off
                b 02 "Put the chip inside the machine"
                b serious "It should be able to start with this piece..."
            else:
                b 01 "It worked!! Good job!"
                b 02 "I can really trust you to get the job done, it's nice to know"
                show tent with vpunch
                show tent with hpunch
                pause 0.5
                show tent with vpunch
                b 01 "Oh, sounds like {b}Mimi{/b} is also hard at work"
                b 02 "Go and find more chips now!"
                $ first_explosion = True
        else:
            show tent_computer off
            b happy 01 "Hey rookie, how is the mining going?"
            b confused "You... you already found a chip??"
            b happy 02 "That's awesome, I like to see results!"
            b 01 "Put the chip inside the machine on my desk, quick!"
            $ first_chip_retrieved = True
    elif second_chip_found and second_chip_retrieved==False:
        b confused "Hello, wh- {size=-10}wait what's happen to...{/size}"
        b happy 01 "{size=+5}Oh you got a new chip!{/size}"
        b 02 "That's great, you really are an exceptional miner!"
        b think "We should be able to get an interaction now"
        b happy 01 "Put this in the machine! Quick!!"
        $ second_chip_retrieved = True
    elif second_chip_retrieved and computer_is_active==False:
        b angry 02 "Put this in the machine! Quick!!"
    elif computer_is_active and hole_is_patched==False:
        b happy 01"Great job!"
        b serious "Soon... soon we should have access to the whole system"
        b happy 01 "Go and find some more chips now"
        b 02 "You definitely gonna get a raise after that"
        $ hole_is_patched = True
    else:
        b happy 01 "Go and find more chips!"
        b 02 "The more we have, the better we can understand this machine"

    scene CAVEBACKCOLOR
    call screen CAVE("TENT")
    return

label wormy_room_06:
    scene room 06 with None
    show wormy angry 02 :
        align (0.5,0.85)

    w 01 "{size=+10}WHHAAA{/size}"
    with vpunch
    w 01  "{size=+5}HOW DARE YOOOU{/size}"
    w 02  "Do I go into your house and start blowing the heck out of things??"
    w 01  "This is your LAST warning"
    w 02  "if you continue further very bad things will happen to you"
    w 01 "{size=+5}I HOPE I WAS CLEAR THIS TIME{/size}"
    w 02 "See you never, looser"

    hide wormy with dissolve
    
    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 06")
    return

label fall_into_hole_sequence:
    scene CAVEBACKCOLOR 
    show room 10 a:
        yoffset 0
        ease 0.5 yoffset -100
    with None
    pause 0.3
    scene black with vpunch
    pause 0.5
    with hpunch
    with vpunch
    pause 1.0
    with vpunch
    c "..."
    pause 1.0
    
    scene hole 01 with dissolve
    scene CAVEBACKCOLOR with None
    show hole 01
    call screen CAVE("HOLE 01")
    return

label hole_creature:
    scene hole 03 with None
    pause 0.5
    show creature amused 01 with Dissolve(1.0)
    c "..."
    c 02 "... You look scared"
    c surprised "A shame, I don't get much visitor"
    c closed "Especially a human"
    c surprised "But your head..."
    c amused 02 "Your head doesn't look very human anymore"
    c 01 "You fell pretty bad"
    c "..."
    c 02 "Don't worry"
    c 01 "The rest seems to still be in the right place"
    c closed "Only human curiosity could have brought you here"
    c surprised "Yes, you are definitely human"
    c amused 02 "Each of you think they are the special one"
    c 01 "Even thought you are so tiny"
    c surprised "It is beyond me why you are this way"
    c amused 01 "But who knows"
    c 02 "Even a little bug can itch a giant's back"
    c closed "..."
    c "You did not fell here to listen to me, right?"
    c amused 01 "Here is a little something, thank you for your company"
    c 02 "I hope you will find your way, little bug"

    hide creature with Dissolve(1.0)
    pause 0.5
    $ second_chip_found = True
    $ renpy.notify("+ You found a computer chip!")
    scene CAVEBACKCOLOR
    call screen CAVE("HOLE 03")
    return

label hole_rescue:
    scene hole 01
    pause 2.0
    m "{size=-10}ugh{/size}"
    m "{size=-10}I wonder where the newbie went{/size}"
    m "{size=-20}I swear I heard something...{/size}"
    with vpunch
    m "{size=-15}Hum?{/size}"
    m "{size=-5}Oh it's you!!{/size}"
    m "{size=-5}How did you end up in this hole?{/size}"
    m "{size=-5}Don't worry, I'll get a rope{/size}"
    scene black with dissolve
    pause 1.0
    scene room 10 a
    show mimi happy 02:
        align (0.8, 1.0)
        yoffset 30-12
        xoffset -7
    with dissolve
    $ hole_rescued = True
    m surprised "Ok, your head is a bit messed up, but nothing too bad"
    m happy 02  "Sorry I don't have any medical supplies, I did what I could"
    m happy 01 "But TNT tape works well enough as a bandage!"
    m sad "Damn, you were taking so long, I was starting to worry"
    m happy 01 "You got very lucky for someone who don't look where they are going!"
    m surprised "Oh, and you found a chip down there?"
    m happy 02 "That's very pro of you"
    m 01 "You can bring it to the {b}boss{/b} I guess, you seem to be walking just fine"
    m 02 "I will make sure you don't fall again, don't worry"

    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 10")
    return

label mimi_hole_dialogue:
    scene room 10 a
    show mimi happy 02:
        align (0.8, 1.0)
        yoffset 30-12
        xoffset -7
    m 01 "You look very funny with that tape all over your face"
    m 02 "hehe"
    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 10")
    return

label mimi_room12:
    scene room 12
    show mimi surprised:
        align (0.7, 0.8)
        offset (-5,-7)
    m surprised "Hey have you seen those drawings?"
    m happy 02 "weird"
    m sad "This place give me some strange vibe sometime"
    m happy 01 "From what I understand there was other humans living there before"
    m 02 "Almost everything is gone now of course, apart from those chips"
    m surprised "They were probably burred deep enough that they weren't looted"
    m happy 01 "hey I know I shouldn't care about that, it's just a job"
    m 02 "I'm just here to blow up rocks hehe"
    m "But I wonder how people used to live hundreds of years ago"

    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 12")
    return

label boss_betray:
    scene room 15 a
    pause 0.5
    show boss happy 02 with Dissolve(1.5)
    b "Oh hey newbie"
    b "What is that? You found another chip?"
    b "That's awesome, this seem to be the last one I needed"
    $ renpy.notify("- You gave the computer chip!")
    b "I appreciate your efforts"
    b "Without knowing it, you contribution will help a brand new era to start"
    b "Sadly, you are not needed in this new world"
    b "I hope you understand"
    b "You know too much about the machine"
    b "I have a important mission to accomplish, and I don't want anyone in my path"
    $ boss_betray = True
    b "Anyone."

    scene black with vpunch
    $ renpy.pause(3.0, hard=True)
    # Explosion
    with flash
    with vpunch
    $ renpy.pause(1.0, hard=True)
    scene room 15 b with Dissolve(1.0)
    scene black
    call screen CAVE("ROOM 15")

label wormy_help:
    scene room 14 b with None
    show wormy angry 02 with dissolve:
        align (0.5,0.85)
    w 01 "HAHA"
    w 02 "That's the sound of me laughing at YOU"
    w 01 "Pitiful human"
    w 02 "You should have been extinct long ago!"
    w 01 "can't even eat dirt and they think they are the ultimate species"
    w 02 "Now you'll never blow things up again, you will never escape!!"
    w 01 "HAHAHA"
    show wormom at turn_black() with dissolve:
        xalign 0.7
    show wormy:
        easein_back 0.5 xoffset -200
    wm "Robert, what is going on?"
    w happy 02 "Oh, hum..."
    w 01 "Hi mom!"
    show wormom at turn_normal() with dissolve
    wm "..."
    wm "What is this human doing here?"
    w 02 "I trapped him!"
    w "..."
    w sad "Ok maybe I had some help"
    w happy 02 "There is that other human that blew the way, but at least this one is trapped now!"
    wm "..."
    wm "We talked about this already"
    wm "Humans are not worth bothering with"
    w angry 02 "But mom!"
    wm "I'm taking care of it from now on, we will have a discussion about it later"
    w sad "Ok..."
    wm "We have some fresh mycelium at home if you need a snack"
    w happy 01b "Oh!! My favorite"
    w happy 02 "Thanks mom, bye human"
    hide wormy with dissolve
    show wormom:
        easein_back 0.5 xalign 0.5
    wm "..."
    wm "Sorry about my son"
    wm "Step aside, I will open a path for you"

    $ passage_open = True
    $ wormy_can_help = False
    show room 14 c with fade

    wm "It should be enough"
    wm "This is all I will do for you."
    wm "Because the kid has a point: your presence has been really annoying"
    wm "But you do not deserve to die here"
    wm "..."
    wm "I better not see you digging here ever again"

    hide wormom with dissolve
    
    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 14")

label mimi_escape:
    scene room 02
    pause 1.0
    scene room 02 with flash
    scene room 02 b with vpunch
    pause 1.0
    show mimi happy 02 :
        align (0.7, 0.8)
        alpha 0.0
        xoffset 100
        parallel:
            ease 0.5 xoffset 0
        parallel: 
            ease 0.5 alpha 1.0
    $ mimi_burried = False
    m 01 "Oh hi there!"
    m 02 "I'm glad to see you here, you will not believe it:"
    m 01"The boss showed up and trapped me in that room"
    m evil 02 "But that was very silly of him"
    m "hehe"
    m 02 "He forgot that I could set up explosive with my eyes closed, let alone in the dark"
    m surprised "He did that to you too? Damn, that didn't arrange your head"
    m happy 02 "Come here a second"
    scene room 02 b
    show mimi happy 02 :
        align (0.7, 0.8)
    with fade
    m "There, that should hold it more tightly"
    m 01 "Lucky you, that was the last bit of tape I had"
    m surprised "But now we need to find out what the boss is up to"
    m sad "This whole thing is really strange..."
    hide mimi with dissolve

    scene CAVEBACKCOLOR
    call screen CAVE("ROOM 02")

label mimi_unlock_flying_car:
    scene camp entrance b with vpunch
    show mimi happy 02 with dissolve:
        align (0.3, 0.8)
        xzoom -1
    m happy 01 "w-what is that sound?!"
    m 02 "..."
    m surprised "oh boy"
    m sad "I... I don't know what that is, is it what the boss has become?"
    m surprised "This abomination don't belong in this world"
    m evil 02 "He tried to kill both of us, we cannot let him get away with that!"
    $ flying_car_accessible = True
    m 01 "Let's use his flying car at the {b}camp entrance{/b}!"
    m 02 "Let's get our revenge"

    show mimi:
        xoffset 0 
        yoffset 0 
        alpha 1.0
        parallel:
            easeout 0.5 xoffset -10 
        parallel:
            easeout 0.5 yoffset 100 
        parallel:
            easeout 0.3 alpha 0.0 
    pause 0.5
    

    scene CAVEBACKCOLOR
    call screen CAVE("CAMP ENTRANCE")



label final_sequence_start:
    scene black with dissolve
    if boss_phase == 2:
        jump phase2_start
    show screen boss(idle=True) with dissolve
    pause 1.5
    m "Oh my, what even is this thing"
    m "One thing is for sure, we need to stop him before he starts destroying things"
    m "Ok partner! We need to get close enough to intercept him!"
    m "Watch out!"
    call screen boss()
    jump phase2_start

label phase2_start:
    $ boss_player_location = 0
    $ lagging_line = boss_player_location
    show screen boss(idle=True) with dissolve
    m "Good job!"
    m "He's clearly not there to discuss, no mercy necessary"
    m "hehe"
    m "Fire at will!!"
    call screen boss()
    show screen boss(idle=True) with flash
    pause 0.5
    $ boss_phase = 3
    show screen boss(idle=True) with dissolve
    m "That's enough!"
    m "Hey big man, listen to us now"
    m "What even are you?! Can you please calm down for a second?"

    b "YOU... HOW DARE YOU OPPOSE ME?!"
    b "I'M HERE TO GET MY REVENGE ON THIS ROTTEN WORLD"
    b "I'M GONNA RULE OVER THE WHOLE LAND, AND FINALLY PUT AN END TO THE CHAOS"
    
    show mimi jumping 01 onlayer screens:
        align (1.0, 0.0)
        alpha 0
        xoffset 20
        parallel:
            ease 0.6 alpha 1.0
        parallel:
            easein_back 0.5 xoffset 0
    m "And you had to eliminate both of us for that?"
    m "Besides, what even is there to rule over? What do you have to gain from a kingdom of rats?!"
    
    b "THIS IS NOT ABOUT WHAT I HAVE TO GAIN, BUT WHAT I HAVE LOST"
    b "THERE IS NO TURNING POINT ANYMORE"
    b "AND I WILL CRUSH ANYONE WHOP OPPOSES ME!!"
    b "ANYONE"

    m "..."
    $ ship_open_top = True
    m "That's not going to happen."
    show mimi jumping 02 onlayer screens
    m "I don't know what went into you, but we don't need a ruler like yourself"
    m "You want to crush this world ugh?"
    m "hehe"
    m "Well,"
    show mimi jumping 03 onlayer screens:
        xoffset 0
        zoom 1.0
        parallel:
            ease 4.5 xoffset -150
        parallel:
            ease 4.5 zoom 0.8

    m "you'll have to crush me first!{w=3.0}{nw}"
    show black onlayer overlay with Dissolve(1.0)
    hide mimi onlayer screens
    hide screen boss 
    scene black with fade
    with flash
    with vpunch
    with hpunch
    pause 1.0
    with vpunch
    pause 2.0
    # "YOU LANDING"
    scene crashsite with dissolve
    call screen CAVE("ENDING 01")
    return

label mimi_final_speech:
    scene mimi crash 01
    pause 2.0
    m "..."
    m "ugh"
    show mimi crash 02
    m "hey"
    m "C'mon, don't make that face"
    m "Did you really think I could go down because of an explosion?"
    m "..."
    m "Well, I think we can forget about our paycheck given the circumstances"
    m "That's fine, I had fun anyway"
    m "But I think I've had enough of blowing stuff up"
    m "At least for a few days"
    m "..."
    m "hhm, do you have a place to live by any chance?"
    m "asking for a friend"
    
    scene black with dissolve

    pause 2.0

    n "Thanks for playing!"

    return
label game_over:
    scene black with flash
    with vpunch
    pause 1.0
    $ boss_gameover = False
    $ boss_player_location = 0
    $ lagging_line = boss_player_location
    $ boss_hp = boss_max_hp
    $ phase2_boss_can_attack = True
    $ phase2_boss_direction = 0
    $ boss_sprite = "idle"
    jump final_sequence_start

init python:
    map = {
        "FLYING CAR": {"dest":{"top":["EOLIENNE"]}, "screen":"flyingCarLocation"},
        "EOLIENNE": {"dest":{"top":["CAMP ENTRANCE"], "bottom":["FLYING CAR", "flying_car_accessible"]}, "screen":"eolienneLocation"},
        "CAMP ENTRANCE": {"dest":{"top":["TENT", "boss_introduction==False "], "bottom":["EOLIENNE"]}, "screen":"campEntranceLocation"},
        "TENT": {"dest":{"top":["CAVE ENTRANCE"],"bottom":["CAMP ENTRANCE"], "right":["COMPUTER", "computer_is_accessible"]}, "screen":"tentLocation"},
        "COMPUTER": {"dest":{"bottom":["TENT"]}, "screen":"computerLocation"},
        "CAVE ENTRANCE": {"dest":{"top":["ROOM 01", "mimi_introduction==False"],"bottom":["TENT"]}, "screen":"caveEntranceLocation"},

        "ROOM 01": {"dest":{"top":["ROOM 02"], "bottom":["CAVE ENTRANCE"]}, "screen":"room01Location"},
        "ROOM 02": {"dest":{"top":["ROOM 03"], "bottom":["ROOM 01"], "right":["ROOM 13", "mimi_burried==False"]}, "screen":"room02Location"},
        "ROOM 03": {"dest":{"top":["ROOM 05", "worm_in_room_3==False"], "left":["ROOM 04", "worm_in_room_3==False"], "bottom":["ROOM 02"]}, "screen":"room03Location"},
        "ROOM 04": {"dest":{"bottom":["ROOM 03"]}, "screen":"room04Location"},
        "ROOM 05": {"dest":{"bottom":["ROOM 03"], "top":["ROOM 06", "first_explosion"]}, "screen":"room05Location"},
        "ROOM 06": {"dest":{"bottom":["ROOM 05", "worm_in_room_6 == False"], "right":["ROOM 07", "worm_in_room_6 == False"]}, "screen":"room06Location"},
        "ROOM 07": {"dest":{"bottom":["ROOM 06"], "left":["ROOM 08"],"top":["ROOM 09"]}, "screen":"room07Location"},
        "ROOM 08": {"dest":{"bottom":["ROOM 07"]}, "screen":"room08Location"},
        "ROOM 09": {"dest":{"bottom":["ROOM 07"], "right":["ROOM 10"]}, "screen":"room09Location"},
        "ROOM 10": {"dest":{"top":["ROOM 11", "hole_is_patched"], "bottom":["ROOM 09"]}, "screen":"room10Location"},
        "ROOM 11": {"dest":{"top":["ROOM 12", "boss_betray==False"], "bottom":["ROOM 10"], "left":["ROOM 14"]}, "screen":"room11Location"},
        "ROOM 12": {"dest":{"bottom":["ROOM 11"], "right":["ROOM 13"]}, "screen":"room12Location"},
        "ROOM 13": {"dest":{"bottom":["ROOM 12", "mimi_burried"], "top":["ROOM 02", "mimi_burried==False"]}, "screen":"room13Location"},
        "ROOM 14": {"dest":{"bottom":["ROOM 11", "boss_betray==False or passage_open"], "top":["ROOM 15"]}, "screen":"room14Location"},
        "ROOM 15": {"dest":{"bottom":["ROOM 14"], "right":["ROOM 16"]}, "screen":"room15Location"},
        "ROOM 16": {"dest":{"bottom":["ROOM 15"]}, "screen":"room16Location"},
        
        "HOLE 01": {"dest":{"top":["HOLE 02"]}, "screen":"hole01Location"},
        "HOLE 02": {"dest":{"bottom":["HOLE 01"], "left":["HOLE 03"], "right":["HOLE 04"]}, "screen":"hole02Location"},
        "HOLE 03": {"dest":{"bottom":["HOLE 02", "second_chip_found"]}, "screen":"hole03Location"},
        "HOLE 04": {"dest":{"left":["HOLE 05"], "bottom":["HOLE 02"]}, "screen":"hole04Location"},
        "HOLE 05": {"dest":{"top":["HOLE 01"], "bottom":["HOLE 04"]}, "screen":"hole05Location"},
        
        "ENDING 01": {"dest":{"top":["ENDING 02"]}, "screen":"ending01Location"},
        "ENDING 02": {"dest":{}, "screen":"ending02Location"},
    }

    def LocationChange(pLocation, pDestination):
        if pDestination not in map[pLocation]["dest"]:
            pDestination = "none"

        # renpy.sound.queue("/audio/sfx/footsteps/384871__ali_6868__left-gravel-footstep-2.wav")
        if pDestination in map[pLocation]["dest"]:
            if (len(map[pLocation]["dest"][pDestination])==1 or eval(map[pLocation]["dest"][pDestination][1])):
                return map[pLocation]["dest"][pDestination][0]
        
        return pLocation



screen CAVE(pLocation = "EOLIENNE"):
    default location = pLocation
    default previous_location = pLocation
    default destination = "none"

    key "K_SPACE" action [SetLocalVariable("previous_location", location), SetLocalVariable("location", LocationChange(location, destination))]

    fixed:
        xysize (1920,1080)

        use LocationDisplay(location, previous_location)